#include <memory.h>
#include <stdio.h>


#define  BUFFER_SIZE 2048
#define  SECTOR_SIZE 512		// С
#define  SETUP_SEC   4          // setup.bin ռõ
#define  SYS_SIZE    0x3000		// system ģռÿռĽһΪ 16 ֽڣ 0x3000 * 16 = 192KB 


unsigned char ucBuffer[BUFFER_SIZE];

/*
			*ļеֲͼ*
	+-----------------------------------------------+
	|			|			|						|
	| bootsect	| 	setup	|		system			|
	|			|			|						|
	+-----------------------------------------------+
    0          1-4			5-388
*/

int main(int argc, char* argv[])
{
	//  5
	if(5 != argc)
	{
		printf("mkfloppy parameter error. \nUsage: mkfloppy.exe bootsect setup system.\n");
		return 1;
	}
	
	//
	// ̾ļ
	//
	FILE *pFloppyFile = fopen(argv[4], "wb");
	if (NULL == pFloppyFile)
	{
		printf("Createing %s failed\n", argv[4]);
		return 1;
	}

	//
	// ȡһļ bootsect.binд̾ĵ 0 
	//
	FILE *pBootSectFile = fopen(argv[1], "rb");
	if (NULL == pBootSectFile)
	{
		printf("Unable to open %s file\n", argv[1]);
		fclose(pFloppyFile);
		return 1;
	}

	fread(ucBuffer, sizeof(unsigned char), SECTOR_SIZE, pBootSectFile);
	int iNum = fwrite(ucBuffer, sizeof(unsigned char), SECTOR_SIZE, pFloppyFile);
	printf("%s ɹд %s! һд %d ֽ \n", argv[1], argv[4], iNum);

	fclose(pBootSectFile);

	//
	// ȡڶļ setup.binд̵ĵ 1 - 4 
	//
	// 
	memset(ucBuffer, 0, BUFFER_SIZE);
		
	FILE *pSetupFile = fopen(argv[2], "rb");
	if (NULL == pSetupFile)
	{
		printf("Unable to open file %s \n", argv[2]);
		fclose(pFloppyFile);
		return 1;
	}
	
	fread(ucBuffer, sizeof(unsigned char), BUFFER_SIZE, pSetupFile);
	iNum = fwrite(ucBuffer, sizeof(unsigned char), BUFFER_SIZE, pFloppyFile);
	printf("%s    ɹд %s! һд %d ֽ\n", argv[2], argv[4], iNum);

	fclose(pSetupFile);
	
	//
	// ȡļ linux011.binд̵ĵ 5 - 388 
	//
	FILE *pSystemFile = fopen(argv[3], "rb");
	if(NULL == pSystemFile)
	{
		printf("Unable to open file %s \n", argv[3]);
		fclose(pFloppyFile);
		return 1;
	}
	
	int i;
	for ( i=0; (iNum = fread(ucBuffer, sizeof(unsigned char), BUFFER_SIZE, pSystemFile)) > 0; i += iNum)
		fwrite(ucBuffer, sizeof(unsigned char), iNum, pFloppyFile);
	printf("%s ɹд %s! һд %d ֽ\n", argv[3], argv[4], i);
	
	fclose(pSystemFile);
	fclose(pFloppyFile);

	return 0;
}



